package reflex.data
{
	import flash.events.EventDispatcher;
	
	import reflex.events.PropertyEvent;

	public class Position extends EventDispatcher implements IPosition, IRange
	{
		
		private var _min:Number;
		private var _max:Number;
		private var _position:Number;
		
		
		[Bindable(event="minChange")]
		public function get min():Number { return _min; }
		public function set min(value:Number):void {
			if(_min == value) {
				return;
			}
			PropertyEvent.dispatchChange(this, "min", _min, _min = value);
		}
		
		[Bindable(event="maxChange")]
		public function get max():Number { return _max;}
		public function set max(value:Number):void {
			if(_max == value) {
				return;
			}
			PropertyEvent.dispatchChange(this, "max", _max, _max = value);
		}
		
		[Bindable(event="positionChange")]
		public function get position():Number { return _position; }		
		public function set position(value:Number):void {
			if(_position == value) {
				return;
			}
			PropertyEvent.dispatchChange(this, "position", _position, _position = value);
		}
		
		public function Position(min:Number = 0, max:Number = 100, position:Number = 0):void {
			super(this);
			_min = min;
			_max = max;
			_position = position;
		}
		
	}
}